<?
	
	$watermarks = Array(
		'copyrights.png',
		'little-checkboard.png',
		'middle-checkboard.png',
		'large-checkboard.png',
		'scan-lines.png',
		'ground1.png',
		'burlap.png',
		'brick.png',
		'cross-lines.png',
		'parque.png',
		'nops.png',
		'little-bricks.png',
		'watermark.png'
	);	
	
	function watermarks_combo($name,$extra='',$def='copyrights.png') {
		global $watermarks;
		
		$ret = "<select name='$name' $extra>";
		$arr = Array();
		
		foreach($watermarks as $fname) {
			$caption = ucwords(str_replace("-"," ",str_replace(".png","",$fname)));
			$arr []= "<option value='$fname'>$caption</option>";
		}
		return $ret.implode("\n",$arr)."</select>";
	}

	function gd_watermark(&$image, $fname) { 
		$WatermarkFile = "./images/watermarks/$fname";
	
		$watermark = @imagecreatefrompng($WatermarkFile);
		if(!$watermark) return false;
		
		imageAlphaBlending($watermark, false); 
		imageSaveAlpha($watermark, true); 
		
		$imageWidth=imageSX($image); 
		$imageHeight=imageSY($image); 
		$watermarkWidth=imageSX($watermark); 
		$watermarkHeight=imageSY($watermark); 
		$coordinate_X = 0;//( $imageWidth - 5) - ( $watermarkWidth); 
		$coordinate_Y = 0;//( $imageHeight - 5) - ( $watermarkHeight); 
		$done = false;
		$lastx = $lasty = 0;
		while(!$done) {
			imagecopy($image, $watermark, $lastx, $lasty, 0, 0, $watermarkWidth, $watermarkHeight); 
			$lastx += $watermarkWidth;
			if($lastx >= $imageWidth) {
				$lastx=0;
				$lasty += $watermarkHeight;
			}
			if($lasty >= $imageHeight)
				$done=true;
		}	 
		
		return $image;
	} 

    function gd_hexgd(&$image,$hex) {
		$R = hexdec(@$hex{0}.@$hex{1});
		$G = hexdec(@$hex{2}.@$hex{3});
		$B = hexdec(@$hex{4}.@$hex{5});

		return imagecolorallocate ($image, $R, $G, $B);    
    }  
    function gd_bar(&$image,$x=0,$y=0,$width,$height,$color="FFFFFF") {
		return imagefilledrectangle ($image, $x, $y, $x+$width, $y+$height, gd_hexgd($image,$color));
    }

    function gd_text(&$image,$x,$y,$text,$color="000000",$font=2) {

		return imagestring ($image, $font, $x, $y, $text, gd_hexgd($image,$color));	
    }
	function gd_loadfont($fname) {
		$f = "./templates/gdf/$fname.gdf";
		if(!file_exists($f)) {
			echo "file not found - $f<br />";
			return false;
		}
		$fn = @imageloadfont($f);
		if($fn === FALSE) return false;
		return $fn;
	}    
	function gd_textwidth($font=1,$text) {
		$ret= 0;
		if($text=='') return 0;
		return (imagefontwidth($font) * strlen($text));// - (imagefontwidth($font)/2);
	}
	function gd_textheight($font=1) {
		return imagefontheight($font);
	}	
    function gd_width(&$image) {
		return imagesx($image);
    }
    function gd_height(&$image) {
		return imagesy($image);
    }    

    function gd_imagewidth($fname) {
		list($width, $height) = getimagesize($fname); 		
		return $width;
    }
    function gd_imageheight($fname) {
		list($width, $height) = getimagesize($fname); 		
		return $height;
    }       
    function gd_copy(&$image,$x,$y,$w,$h) {
		$ret=imagecreatetruecolor($w, $h); 
		imagecopy($ret,$image, 0, 0, $x, $y, $w, $h);    
		
		return $ret; 
    }
    function gd_paste(&$from,$to,$x=0,$y=0) {
		imagecopymerge($to, $from, $x, $x, 0, 0, imagesx($from), imagesy($from), 100);      
    }
    function gd_resize(&$image,$w,$h) {
		$ret=imagecreatetruecolor($w, $h); 
		imagecopyresampled ($ret,$image, 0, 0, 0, 0, $w, $h, imagesx($image), imagesy($image));  
	
		return $ret; 
    }
  
    function gd_newimage($width,$height) {
		return imagecreatetruecolor($width, $height); 
    }
    function gd_pixeltrans(&$image,$color) {
		return imagecolortransparent ($image, gd_hexgd($image,$color));    
    }
    
    function gd_line(&$image,$x,$y,$x2,$y2,$color="000000") {
		return imageline($image, $x,$y,$x2,$y2,gd_hexgd($image,$color));
    }
    function gd_rectangle(&$image,$x,$y,$w,$h,$color="000000") {
		$col = gd_hexgd($image,$color);
		
		imageline($image, $x,$y,$x,$y+$h,$col); //left
		imageline($image, $x,$y,$x+$w,$y,$col); //top
		imageline($image, $x+$w,$y,$x+$w,$y+$h,$col); //right
		imageline($image, $x,$y+$h,$x+$w,$y+$h,$col); //bottom
		
    }
    
    function gd_loadimage($fname) { //ignore ext e.g. for xbm and xpm load jpg
		$arr = explode(".",$fname);
		$ext = strtolower($arr[count($arr)-1]);
		$func = 'imagecreatefrom';
		switch($ext) {
			case 'jpg' :
			case 'jpeg':
			case 'jpe' :  $func .= 'jpeg'; break;
			case 'png' :  $func .= 'png'; break;
			case 'gif' :  $func .= 'gif'; break;
			case 'xbm' :  $func .= 'xbm'; break;
			case 'wbmp':  $func .= 'wbmp'; break;
	

		}
		if(!function_exists($func))
			return false;
		
		$res = @$func($fname);;
		if(!$res)
			$res = @imagecreatefromjpeg($fname);
		if(!$res) return false;
		
		return $res;
		
    }
    function gd_loadimage_orig($fname) {
		if(!file_exists($fname)) return false;
		
		$arr = explode(".",$fname);
		$ext = strtolower($arr[count($arr)-1]);

		if($ext=='jpe' or $ext == 'jpg') $ext = 'jpeg';
		
		$func = "imagecreatefrom$ext";			
				
		if(!function_exists($func)) 
			return false;

		return @$func($fname);
		
    }    
	function gd_fit(&$image, $target) { 
	
		//takes the larger size of the width and height and applies the  
		//formula accordingly...this is so this script will work  
		//dynamically with any size image 
		
		$width = gd_width($image);
		$height = gd_height($image);
		
		if ($width > $height) { 
			$percentage = ($target / $width); 
		} else { 
			$percentage = ($target / $height); 
		} 
		
		//gets the new value and applies the percentage, then rounds the value 
		$width = round($width * $percentage); 
		$height = round($height * $percentage); 
		
		//returns the new sizes in html image tag format...this is so you 
		//can plug this function inside an image tag and just get the 
		
		return gd_resize($image,$width,$height);
		
	} 
	function gd_getfit(&$image, $target) { 
	
		//takes the larger size of the width and height and applies the  
		//formula accordingly...this is so this script will work  
		//dynamically with any size image 
		
		$width = gd_width($image);
		$height = gd_height($image);
		
		if ($width > $height) { 
			$percentage = ($target / $width); 
		} else { 
			$percentage = ($target / $height); 
		} 
		
		//gets the new value and applies the percentage, then rounds the value 
		$width = round($width * $percentage); 
		$height = round($height * $percentage); 
		
		//returns the new sizes in html image tag format...this is so you 
		//can plug this function inside an image tag and just get the 
		
		return Array('width'=>$width,'height'=>$height);
		
	} 	
    
    
    
    
    function write_jpeg(&$image,$fname,$quality=100) {
		if (function_exists("imagejpeg"))
			return @imagejpeg($image,$fname,$quality); 
		return false;
    }
    function write_png(&$image,$fname,$comp=9) {
		if (function_exists("imagejpng"))    
		if (function_exists("imagejpng"))    
			return @imagepng($image,$fname,$comp); 
		return false;			
    }    
    function write_gif(&$image,$fname) {
		if (function_exists("imagegif"))    
			return @imagegif($image,$fname); 
		return false;			
    }     
    
    
    
    ///////////////////
$mime_types = Array(
			'ez' => "application/andrew-inset",
			'hqx' => "application/mac-binhex40",
			'cpt' => "application/mac-compactpro",
			'doc' => "application/msword",
			'class' => "application/octet-stream",
			'exe' => "application/octet-stream",
			'lzh' => "application/octet-stream",
			'lha' => "application/octet-stream",
			'dms' => "application/octet-stream",
			'bin' => "application/octet-stream",
			'oda' => "application/oda",
			'pdf' => "application/pdf",
			'ps' => "application/postscript",
			'eps' => "application/postscript",
			'ai' => "application/postscript",
			'rtf' => "application/rtf",
			'smil' => "application/smil",
			'smi' => "application/smil",
			'mif' => "application/vnd.mif",
			'ppt' => "application/vnd.ms-powerpoint",
			'slc' => "application/vnd.wap.slc",
			'sic' => "application/vnd.wap.sic",
			'wmlc' => "application/vnd.wap.wmlc",
			'wmlsc' => "application/vnd.wap.wmlscriptc",
			'bcpio' => "application/x-bcpio",
			'bz2' => "application/x-bzip2",
			'vcd' => "application/x-cdlink",
			'pgn' => "application/x-chess-pgn",
			'cpio' => "application/x-cpio",
			'csh' => "application/x-csh",
			'dxr' => "application/x-director",
			'dir' => "application/x-director",
			'dcr' => "application/x-director",
			'dvi' => "application/x-dvi",
			'spl' => "application/x-futuresplash",
			'gtar' => "application/x-gtar",
			'tgz' => "application/x-gzip",
			'gz' => "application/x-gzip",
			'hdf' => "application/x-hdf",
			'js' => "application/x-javascript",
			'kwt' => "application/x-kword",
			'kwd' => "application/x-kword",
			'ksp' => "application/x-kspread",
			'kpt' => "application/x-kpresenter",
			'kpr' => "application/x-kpresenter",
			'chrt' => "application/x-kchart",
			'kil' => "application/x-killustrator",
			'skm' => "application/x-koan",
			'skt' => "application/x-koan",
			'skd' => "application/x-koan",
			'skp' => "application/x-koan",
			'latex' => "application/x-latex",
			'cdf' => "application/x-netcdf",
			'nc' => "application/x-netcdf",
			'rpm' => "application/x-rpm",
			'sh' => "application/x-sh",
			'shar' => "application/x-shar",
			'swf' => "application/x-shockwave-flash",
			'sit' => "application/x-stuffit",
			'sv4cpio' => "application/x-sv4cpio",
			'sv4crc' => "application/x-sv4crc",
			'tar' => "application/x-tar",
			'tcl' => "application/x-tcl",
			'tex' => "application/x-tex",
			'texi' => "application/x-texinfo",
			'texinfo' => "application/x-texinfo",
			'roff' => "application/x-troff",
			'tr' => "application/x-troff",
			't' => "application/x-troff",
			'man' => "application/x-troff-man",
			'me' => "application/x-troff-me",
			'ms' => "application/x-troff-ms",
			'ustar' => "application/x-ustar",
			'src' => "application/x-wais-source",
			'zip' => "application/zip",
			'snd' => "audio/basic",
			'au' => "audio/basic",
			'kar' => "audio/midi",
			'midi' => "audio/midi",
			'mid' => "audio/midi",
			'mp3' => "audio/mpeg",
			'mp2' => "audio/mpeg",
			'mpga' => "audio/mpeg",
			'aifc' => "audio/x-aiff",
			'aiff' => "audio/x-aiff",
			'aif' => "audio/x-aiff",
			'rm' => "audio/x-pn-realaudio",
			'ram' => "audio/x-pn-realaudio",
			'ra' => "audio/x-realaudio",
			'wav' => "audio/x-wav",
			'xyz' => "chemical/x-pdb",
			'pdb' => "chemical/x-pdb",
			'gif' => "image/gif",
			'ief' => "image/ief",
			'jpe' => "image/jpeg",
			'jpg' => "image/jpeg",
			'jpeg' => "image/jpeg",
			'png' => "image/png",
			'tif' => "image/tiff",
			'tiff' => "image/tiff",
			'wbmp' => "image/vnd.wap.wbmp",
			'ras' => "image/x-cmu-raster",
			'pnm' => "image/x-portable-anymap",
			'pbm' => "image/x-portable-bitmap",
			'pgm' => "image/x-portable-graymap",
			'ppm' => "image/x-portable-pixmap",
			'rgb' => "image/x-rgb",
			'xbm' => "image/x-xbitmap",
			'xpm' => "image/x-xpixmap",
			'xwd' => "image/x-xwindowdump",
			'iges' => "model/iges",
			'igs' => "model/iges",
			'silo' => "model/mesh",
			'mesh' => "model/mesh",
			'msh' => "model/mesh",
			'vrml' => "model/vrml",
			'wrl' => "model/vrml",
			'css' => "text/css",
			'txt' => "text/plain",
			'asc' => "text/plain",
			'rtx' => "text/richtext",
			'rtf' => "text/rtf",
			'sgm' => "text/sgml",
			'sgml' => "text/sgml",
			'tsv' => "text/tab-separated-values",
			'sl' => "text/vnd.wap.sl",
			'si' => "text/vnd.wap.si",
			'wml' => "text/vnd.wap.wml",
			'wmls' => "text/vnd.wap.wmlscript",
			'etx' => "text/x-setext",
			'xml' => "text/xml",
			'mpe' => "video/mpeg",
			'mpg' => "video/mpeg",
			'mpeg' => "video/mpeg",
			'mov' => "video/quicktime",
			'qt' => "video/quicktime",
			'avi' => "video/x-msvideo",
			'movie' => "video/x-sgi-movie",
			'ice' => "x-conference/x-cooltalk",
			'htm' => "text/html",
			'html' => "text/html"
		);
		
	function get_mime_ext($type) {
		global $mime_types;
		return array_search($type,$mime_types);
	}    
	
	
	////////////ZIP CLASS


	if(!defined("FORCE_GZIP"))
		die("gzip not found");

    // official ZIP file format: http://www. // pkware.com/appnote.txt

    class zipfile  
    {  

        var $datasec = array(); // array to store compressed data
        var $ctrl_dir = array(); // central directory   
        var $eof_ctrl_dir = "\x50\x4b\x05\x06\x00\x00\x00\x00"; //end of Central directory record
        var $old_offset = 0;

        function add_dir($name)   

        // adds "directory" to archive - do this before putting any files in directory!
        // $name - name of directory... like this: "path/"
        // ...then you can add files using add_file with names like "path/file.txt"
        {  
            $name = str_replace("\\", "/", $name);  

            $fr = "\x50\x4b\x03\x04";
            $fr .= "\x0a\x00";    // ver needed to extract
            $fr .= "\x00\x00";    // gen purpose bit flag
            $fr .= "\x00\x00";    // compression method
            $fr .= "\x00\x00\x00\x00"; // last mod time and date

            $fr .= pack("V",0); // crc32
            $fr .= pack("V",0); //compressed filesize
            $fr .= pack("V",0); //uncompressed filesize
            $fr .= pack("v", strlen($name) ); //length of pathname
            $fr .= pack("v", 0 ); //extra field length
            $fr .= $name;  
            // end of "local file header" segment

            // no "file data" segment for path

            // "data descriptor" segment (optional but necessary if archive is not served as file)
            $fr .= pack("V",@$crc); //crc32
            $fr .= pack("V",@$c_len); //compressed filesize
            $fr .= pack("V",@$unc_len); //uncompressed filesize

            // add this entry to array
            $this -> datasec[] = $fr;

            $new_offset = strlen(implode("", $this->datasec));

            // ext. file attributes mirrors MS-DOS directory attr byte, detailed
            // at http://support.microsoft.com/support/kb/articles/Q125/0/19.asp

            // now add to central record
            $cdrec = "\x50\x4b\x01\x02";
            $cdrec .="\x00\x00";    // version made by
            $cdrec .="\x0a\x00";    // version needed to extract
            $cdrec .="\x00\x00";    // gen purpose bit flag
            $cdrec .="\x00\x00";    // compression method
            $cdrec .="\x00\x00\x00\x00"; // last mod time & date
            $cdrec .= pack("V",0); // crc32
            $cdrec .= pack("V",0); //compressed filesize
            $cdrec .= pack("V",0); //uncompressed filesize
            $cdrec .= pack("v", strlen($name) ); //length of filename
            $cdrec .= pack("v", 0 ); //extra field length   
            $cdrec .= pack("v", 0 ); //file comment length
            $cdrec .= pack("v", 0 ); //disk number start
            $cdrec .= pack("v", 0 ); //internal file attributes
            $ext = "\x00\x00\x10\x00";
            $ext = "\xff\xff\xff\xff";  
            $cdrec .= pack("V", 16 ); //external file attributes  - 'directory' bit set

            $cdrec .= pack("V", $this -> old_offset ); //relative offset of local header
            $this -> old_offset = $new_offset;

            $cdrec .= $name;  
            // optional extra field, file comment goes here
            // save to array
            $this -> ctrl_dir[] = $cdrec;  

             
        }


        function add_file($data, $name)   

        // adds "file" to archive   
        // $data - file contents
        // $name - name of file in archive. Add path if your want

        {  
            $name = str_replace("\\", "/", $name);  
            //$name = str_replace("\\", "\\\\", $name);

            $fr = "\x50\x4b\x03\x04";
            $fr .= "\x14\x00";    // ver needed to extract
            $fr .= "\x00\x00";    // gen purpose bit flag
            $fr .= "\x08\x00";    // compression method
            $fr .= "\x00\x00\x00\x00"; // last mod time and date

            $unc_len = strlen($data);  
            $crc = crc32($data);  
            $zdata = gzcompress($data);  
            $zdata = substr( substr($zdata, 0, strlen($zdata) - 4), 2); // fix crc bug
            $c_len = strlen($zdata);  
            $fr .= pack("V",$crc); // crc32
            $fr .= pack("V",$c_len); //compressed filesize
            $fr .= pack("V",$unc_len); //uncompressed filesize
            $fr .= pack("v", strlen($name) ); //length of filename
            $fr .= pack("v", 0 ); //extra field length
            $fr .= $name;  
            // end of "local file header" segment
             
            // "file data" segment
            $fr .= $zdata;  

            // "data descriptor" segment (optional but necessary if archive is not served as file)
            $fr .= pack("V",@$crc); //crc32
            $fr .= pack("V",@$c_len); //compressed filesize
            $fr .= pack("V",@$unc_len); //uncompressed filesize

            // add this entry to array
            $this -> datasec[] = $fr;

            $new_offset = strlen(implode("", $this->datasec));

            // now add to central directory record
            $cdrec = "\x50\x4b\x01\x02";
            $cdrec .="\x00\x00";    // version made by
            $cdrec .="\x14\x00";    // version needed to extract
            $cdrec .="\x00\x00";    // gen purpose bit flag
            $cdrec .="\x08\x00";    // compression method
            $cdrec .="\x00\x00\x00\x00"; // last mod time & date
            $cdrec .= pack("V",$crc); // crc32
            $cdrec .= pack("V",$c_len); //compressed filesize
            $cdrec .= pack("V",$unc_len); //uncompressed filesize
            $cdrec .= pack("v", strlen($name) ); //length of filename
            $cdrec .= pack("v", 0 ); //extra field length   
            $cdrec .= pack("v", 0 ); //file comment length
            $cdrec .= pack("v", 0 ); //disk number start
            $cdrec .= pack("v", 0 ); //internal file attributes
            $cdrec .= pack("V", 32 ); //external file attributes - 'archive' bit set

            $cdrec .= pack("V", $this -> old_offset ); //relative offset of local header
    //      &n // bsp; echo "old offset is ".$this->old_offset.", new offset is $new_offset<br>";
            $this -> old_offset = $new_offset;

            $cdrec .= $name;  
            // optional extra field, file comment goes here
            // save to central directory
            $this -> ctrl_dir[] = $cdrec;  
        }

        function file() { // dump out file   
            $data = implode("", $this -> datasec);  
            $ctrldir = implode("", $this -> ctrl_dir);  

            return   
                $data.  
                $ctrldir.  
                $this -> eof_ctrl_dir.  
                pack("v", sizeof($this -> ctrl_dir)).     // total # of entries "on this disk"
                pack("v", sizeof($this -> ctrl_dir)).     // total # of entries overall
                pack("V", strlen($ctrldir)).             // size of central dir
                pack("V", strlen($data)).                 // offset to start of central dir
                "\x00\x00";                             // .zip file comment length
        }
		  function writeZip($fname) {
			if(!($f=@fopen($fname,"w"))) return false;
			if(!@fwrite($f,$this->file())) return false;
			@fclose($f);
			return true;
		  }
		  
		  function add_data_file($fname,$dir='',$as='') {
			str_replace("\\","/",$fname);
			if(!file_exists($fname))
				return false;
			if($as =='') $as = $fname;
			$f= @fopen($fname,"r");
			if(!$f) return false;
			$data = @fread($f,filesize($fname));
			@fclose($f);
			$this->add_file($data,"$dir$fname");
		  }
    }  

?>